<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>fwConfigurationDB: JCOP Framework Configuration Database component</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">fwConfigurationDB
   &#160;<span id="projectnumber">8.4.3</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li class="current"><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('index.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">JCOP Framework Configuration Database component </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="GettingStarted"></a>
Getting started</h1>
<p>In this section you will find a list of most useful functions.</p>
<h2><a class="anchor" id="qstart_generalRemarks"></a>
General Remarks</h2>
<h3><a class="anchor" id="qstart_ExceptionHandling"></a>
Exception Handling</h3>
<p>Following the general JCOP Framework conventions each function contains a parameter called <em>exceptionInfo</em> of <em>dyn_string&amp;</em> type. This parameter is used to pass the information about errors and exceptions, and should always be used to handle the exception conditions. In normal conditions, when no problems were encountered and a function finished succesfully the contents of the <em>exceptionInfo</em> variable will be empty; otherwise, it will contain the information about the nature of the problem. This information may be displayed to the user in a standard exception handling dialog box (if the function is executed from within a UI manager) or printed to the log file. If the function is executed in non-UI manager the actual method of handling the situation of exception is to be chosen by the application developer. One should always check the contents of the <em>exceptionInfo</em> after each call to the API functions of the ConfigurationDB tool.</p>
<p>Example of error-handling in a panel: </p><div class="fragment"><div class="line">main()</div>
<div class="line">{</div>
<div class="line">    dyn_string exceptionInfo;</div>
<div class="line">    <span class="keywordtype">int</span> param=1;</div>
<div class="line"> </div>
<div class="line">    fwConfigurationDB_someFunction(param,exceptionInfo);</div>
<div class="line">    <span class="keywordflow">if</span> (dynlen(exceptionInfo)) { fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>; }</div>
<div class="line">    <span class="comment">// the code goes on ...</span></div>
<div class="line">} </div>
</div><!-- fragment --><p>Example of error handling in a control script: </p><div class="fragment"><div class="line"><span class="keywordtype">bool</span> myFunction()</div>
<div class="line">{</div>
<div class="line">    <span class="comment">// returns TRUE on success...</span></div>
<div class="line"> </div>
<div class="line">    dyn_string exceptionInfo;</div>
<div class="line">    <span class="keywordtype">int</span> param=1;</div>
<div class="line"> </div>
<div class="line">    fwConfigurationDB_someFunction(param,exceptionInfo);</div>
<div class="line">    <span class="keywordflow">if</span> (dynlen(exceptionInfo)) { DebugN(exceptionInfo); <span class="keywordflow">return</span> FALSE; }</div>
<div class="line">    <span class="comment">// the code goes on ...</span></div>
<div class="line">    <span class="keywordflow">return</span> TRUE</div>
<div class="line">} </div>
</div><!-- fragment --><h3><a class="anchor" id="qstart_initialization"></a>
Initialization</h3>
<p>Before you start using any of the functions, you need to make sure that the tool is initialized properly. The initialization procedure takes care of opening the connection to the database server, selecting the default recipe types and initialization of internal data structures.</p>
<p>To initialize the tool, place the call to <a class="el" href="group__ErrorCodes.html#ga43d05490668849e2a99e320f93ed38cf">fwConfigurationDB_initialize</a> function. Typicaly, one will use the default setup, hence the empty string will be passed as the <em>setupName</em> parameter. The following code could be used in the initialization of the panel: </p><div class="fragment"><div class="line">dyn_string exceptionInfo;</div>
<div class="line"><a class="code" href="group__ErrorCodes.html#ga43d05490668849e2a99e320f93ed38cf">fwConfigurationDB_initialize</a>(<span class="stringliteral">&quot;&quot;</span>,exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo);<span class="keywordflow">return</span>};</div>
<div class="line"><span class="comment">// further initializations, as needed...</span></div>
<div class="ttc" id="agroup__ErrorCodes_html_ga43d05490668849e2a99e320f93ed38cf"><div class="ttname"><a href="group__ErrorCodes.html#ga43d05490668849e2a99e320f93ed38cf">fwConfigurationDB_initialize</a></div><div class="ttdeci">synchronized void fwConfigurationDB_initialize(string setupName, dyn_string &amp;exceptionInfo)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB.ctl:225</div></div>
</div><!-- fragment --><p>To simply ensure the initialization was performed, without unnecessary forcing of re-initialization (which involve reopening database connections and hence may be a lengthy process), one may use the <a class="el" href="group__ErrorCodes.html#gabfe9731975c38c37302fbfe101a2be58">fwConfigurationDB_checkInit</a> function instead; it will chech if the tool has already been initialized, and call the <a class="el" href="group__ErrorCodes.html#ga43d05490668849e2a99e320f93ed38cf">fwConfigurationDB_initialize</a> if needed.</p>
<p>Please note, that <a class="el" href="group__ErrorCodes.html#gabfe9731975c38c37302fbfe101a2be58">fwConfigurationDB_checkInit</a> does not allow to specify the setup parameter: the default setup is always used. We therefore suggest that <a class="el" href="group__ErrorCodes.html#ga43d05490668849e2a99e320f93ed38cf">fwConfigurationDB_initialize</a> is always used for the first initialization, and <a class="el" href="group__ErrorCodes.html#gabfe9731975c38c37302fbfe101a2be58">fwConfigurationDB_checkInit</a> is used later, as a "safeguard" function.</p>
<h3><a class="anchor" id="qstart_devLists"></a>
Device lists</h3>
<p>A number of API functions in the ConfigurationDB requires the list of devices (or items) as one of the parameters of the <em>dyn_string</em> type. The device (item) name is: </p><ul>
<li>the DataPoint Name for the HARDWARE view </li>
<li>the DataPoint Alias for the LOGICAL view Device (item) name contains system name may be significant. In the case of devices in HARDWARE hierarchy, the names of the devices always need to contain system name; any device name in a list that does not contain system name will automatically get it prepended (the name of current system will be used). For the LOGICAL hierarchy, on the contrary, the presence of system name in the device (item) name is meaningful and specifies the mode of operation (i.e. working without system name).</li>
</ul>
<p>Some functions consider passing an empty list as "no sub-selection specified", others require that the devices (items) are specified explicitely. To ease the task of building the device lists for the case where devices form a hierarchy, the <a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#a2160aaa26b8d3c747f689aeb4b4a4b69">fwConfigurationDB_getHierarchyFromPVSS</a> may be used. It returns a list of devices (items) that are children (and grand-children, ...) of a specified top-level device (item) in a specified hierarchy. The following example shows the use of this function: the list of all children of the "CAEN" node on the local system will be extracted (i.e. the list of all CAEN crates, their boards, and channels): </p><div class="fragment"><div class="line"><span class="keywordtype">string</span> rootNode=getSystemName()+<span class="stringliteral">&quot;CAEN&quot;</span>;</div>
<div class="line">dyn_string deviceList;</div>
<div class="line">dyn_string exceptionInfo;</div>
<div class="line"><a class="code" href="fwConfigurationDB__Hierarchies_8ctl.html#a2160aaa26b8d3c747f689aeb4b4a4b69">fwConfigurationDB_getHierarchyFromPVSS</a>(rootNode, fwDevice_HARDWARE,</div>
<div class="line">                       deviceList, exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="ttc" id="afwConfigurationDB__Hierarchies_8ctl_html_a2160aaa26b8d3c747f689aeb4b4a4b69"><div class="ttname"><a href="fwConfigurationDB__Hierarchies_8ctl.html#a2160aaa26b8d3c747f689aeb4b4a4b69">fwConfigurationDB_getHierarchyFromPVSS</a></div><div class="ttdeci">void fwConfigurationDB_getHierarchyFromPVSS(string rootNode, string hierarchyType, dyn_string &amp;nodeList, dyn_string &amp;exceptionInfo, string system=&quot;&quot;, string includeRootNode=TRUE)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Hierarchies.ctl:296</div></div>
</div><!-- fragment --><p>For more information about device lists and hierarchies see also <a class="el" href="index.html#qstart_hierarchies">Hierarchies</a> section of this Quick Start.</p>
<h2><a class="anchor" id="qstart_recipes"></a>
Recipes</h2>
<p>Recipes store dynamic configuration data for a set of devices (items): these contain the values of device elements and the settings of alerts. Recipes may be stored either in a database or in a cache (a local datapoint).</p><ul>
<li><p class="startli">A recipe is identified by a unique name (below also refered to as "tag" or "cacheName"). It is defined for a set of devices belonging to the same hierarchy.</p>
<p class="startli">The use of recipes typicaly involve two steps: retrieving the recipe data from a source, followed by storing these data or applying it to a system. This involves the use of the <a class="el" href="index.html#recipeObject">recipeObject</a> data structure as an intermediate, volatile storage variable, which holds the complete information about a recipe.</p>
<p class="startli">Recipe-related operations usually accept the <a class="el" href="index.html#qstart_devLists">Device lists</a> as parameters, to either specify the list of devices (items) for which a recipe is created, or to make a sub-selection of a recipe.</p>
</li>
</ul>
<h3><a class="anchor" id="qstart_recipe_remote"></a>
Remote recipes and Remote Devices</h3>
<p>It is possible to handle recipe caches stroed in remote distributed systems, as well as to have devices from remote systems in (local or remote) recipes.</p>
<p>To load or save a recipe from/toa cache in a remote system, it is sufficient to prefix that remote recipe name with system name and a colon, eg. "dist_2:MYRECIPE". Note that this is the recipe cache name in this string, and not the recipe cache datapoint; this naming is purely conventional.</p>
<p>A recipe could be loaded from cache, or a database even though some devices are non-existent (missing datapoints, for HARDWARE hierarchy), or could not be resolved (LOGICAL hierarchy). Such recipe, however, would not work when being applied. In addition, an information message will be printed in the log for every non-resolved device:</p>
<blockquote class="doxtable">
<p>WCCOAui (1), 2018.03.26 08:34:50.919, CTRL, INFO, 2002/fwConfigurationDB, fwConfigurationDB_getRecipeFromCache, Cannot resolve device MyDet2/CHN19 in recipe: sys22:Rec22, Settings loaded yet will be skipped when applying recipe. </p>
</blockquote>
<p><br  />
 By default, when resolving LOGICAL devices, only local system's aliases will be taken into account, following the JCOP Framework's locality principle, and to make sure that performance is not affected in large distributed systems possibly containing millions of aliases. However, it is possible to have aliases of remote systems also resolved in the following circumstances:</p>
<ul>
<li>if a recipe is loaded from a remote system, then aliases will be looked up in this system in addition to the local system.</li>
<li>if one uses the optional systemName parameter of <a class="el" href="group__RecipeFunctions.html#ga90c82b459ca4938b22362a41ffecf141">fwConfigurationDB_loadRecipeFromCache</a> then it is meant to be a comma-separated list of systems in which the aliases will be searched for to resolve logical devices.</li>
<li>ultimately, if the global variable <a class="el" href="fwConfigurationDB_8ctl.html#ae22458ce57b9540e593ac254b46956d7">fwConfigurationDB_allowResolveRemote</a> is set to TRUE, then all the connected distributed systems will be searched through; note that for large systems this may have impact on performance and resource consumption.</li>
</ul>
<h3><a class="anchor" id="qstart_getAvailableRecipes"></a>
Getting the list of available recipes</h3>
<p>To get the list of available recipe caches one should use the functions: </p><ul>
<li><a class="el" href="group__RecipeFunctions.html#gaed5760a8cabd9bca77dec1714ac11799">fwConfigurationDB_getRecipesInCache</a> <div class="fragment"><div class="line">dyn_string exceptionInfo, recipeList;</div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#gaed5760a8cabd9bca77dec1714ac11799">fwConfigurationDB_getRecipesInCache</a> ( recipeList,exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line">RecipeSelector.items=recipeList;</div>
<div class="ttc" id="agroup__RecipeFunctions_html_gaed5760a8cabd9bca77dec1714ac11799"><div class="ttname"><a href="group__RecipeFunctions.html#gaed5760a8cabd9bca77dec1714ac11799">fwConfigurationDB_getRecipesInCache</a></div><div class="ttdeci">void fwConfigurationDB_getRecipesInCache(dyn_string &amp;recipeList, dyn_string &amp;exceptionInfo, string deviceName=&quot;&quot;, string systemName=&quot;&quot;)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Recipes.ctl:563</div></div>
</div><!-- fragment --> </li>
<li>the same function mat be used to get the list of recipes in recipe cache, defined for specified device <div class="fragment"><div class="line">dyn_string exceptionInfo, recipeList;</div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#gaed5760a8cabd9bca77dec1714ac11799">fwConfigurationDB_getRecipesInCache</a> ( recipeList,exceptionInfo,<span class="stringliteral">&quot;MyDCS/SubSys1/device1&quot;</span>);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line">RecipeSelector.items=recipeList;</div>
</div><!-- fragment --> </li>
<li><a class="el" href="group__RecipeFunctions.html#gadafb27a60dc02862e5017876d4c229df">fwConfigurationDB_getRecipesInDB</a> to get the list of all recipes stored in the database: <div class="fragment"><div class="line">dyn_string exceptionInfo, recipeList;</div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#gadafb27a60dc02862e5017876d4c229df">fwConfigurationDB_getRecipesInDB</a>(recipeList, exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line">RecipeSelector.items=recipeList;</div>
<div class="ttc" id="agroup__RecipeFunctions_html_gadafb27a60dc02862e5017876d4c229df"><div class="ttname"><a href="group__RecipeFunctions.html#gadafb27a60dc02862e5017876d4c229df">fwConfigurationDB_getRecipesInDB</a></div><div class="ttdeci">void fwConfigurationDB_getRecipesInDB(dyn_string &amp;recipeList, dyn_string &amp;exceptionInfo, string deviceName=&quot;&quot;)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Recipes.ctl:539</div></div>
</div><!-- fragment --> </li>
<li>the same function mat be used to get the list of recipes in the database, defined for specified device <div class="fragment"><div class="line">dyn_string exceptionInfo, recipeList;</div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#gadafb27a60dc02862e5017876d4c229df">fwConfigurationDB_getRecipesInDB</a> ( recipeList,exceptionInfo,<span class="stringliteral">&quot;MyDCS/SubSys1/device1&quot;</span>);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line">RecipeSelector.items=recipeList;</div>
</div><!-- fragment --></li>
</ul>
<h3><a class="anchor" id="qstart_recipe_load"></a>
Loading stored Recipes</h3>
<p>To load stored recipe to a recipeObject one should use the functions: </p><ul>
<li><a class="el" href="group__RecipeFunctions.html#ga90c82b459ca4938b22362a41ffecf141">fwConfigurationDB_loadRecipeFromCache</a> to load a recipe from recipe cache </li>
<li><a class="el" href="group__RecipeFunctions.html#ga36a6faf13d4f9f4cd17362f5a659e5dc">fwConfigurationDB_loadRecipeFromDB</a> to load a recipe from the database</li>
</ul>
<p>Note that these function do not overwrite the passed <em>recipeObject</em>, but rather perform "append" operations by means of the <a class="el" href="group__RecipeFunctions.html#gaa03d6c4cc18c9cae3449b957f3b1324e">fwConfigurationDB_combineRecipes</a> function, so combining the recipes is easy...</p>
<div class="fragment"><div class="line"><span class="comment">// combine two recipes, and apply it to running system</span></div>
<div class="line">dyn_string exceptionInfo;</div>
<div class="line">dyn_dyn_mixed recipeObject;</div>
<div class="line"><span class="keywordtype">string</span> hierarchy=fwDevice_LOGICAL</div>
<div class="line">dyn_string deviceList; <span class="comment">// empty: get all devices...</span></div>
<div class="line"> </div>
<div class="line"><span class="comment">// get &quot;coarse&quot; settings from the database</span></div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#ga36a6faf13d4f9f4cd17362f5a659e5dc">fwConfigurationDB_loadRecipeFromDB</a>(<span class="stringliteral">&quot;hv_coarse_settings&quot;</span>,deviceList, hierarchy,</div>
<div class="line">                recipeObject,exceptionName,<span class="stringliteral">&quot;&quot;</span>);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line"> </div>
<div class="line"><span class="comment">// append &quot;fine-tune&quot; settings stored in the cache</span></div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#ga90c82b459ca4938b22362a41ffecf141">fwConfigurationDB_loadRecipeFromCache</a>(<span class="stringliteral">&quot;hv_fine_tune_settings&quot;</span>, deviceList, hierarchy,</div>
<div class="line">                                        recipeObject,exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line"> </div>
<div class="line"><span class="comment">// apply resulting recipe:</span></div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#ga3c127700937f5b3144dcaaaa5c5a7c8a">fwConfigurationDB_applyRecipe</a>   (recipeObject, hierarchy, exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="ttc" id="agroup__RecipeFunctions_html_ga36a6faf13d4f9f4cd17362f5a659e5dc"><div class="ttname"><a href="group__RecipeFunctions.html#ga36a6faf13d4f9f4cd17362f5a659e5dc">fwConfigurationDB_loadRecipeFromDB</a></div><div class="ttdeci">void fwConfigurationDB_loadRecipeFromDB(string recipeName, dyn_string deviceList, string hierarchyType, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo, string systemName=&quot;&quot;, string topDevice=&quot;&quot;, time validAt=0)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Recipes.ctl:234</div></div>
<div class="ttc" id="agroup__RecipeFunctions_html_ga3c127700937f5b3144dcaaaa5c5a7c8a"><div class="ttname"><a href="group__RecipeFunctions.html#ga3c127700937f5b3144dcaaaa5c5a7c8a">fwConfigurationDB_applyRecipe</a></div><div class="ttdeci">void fwConfigurationDB_applyRecipe(dyn_dyn_mixed recipeObject, string hierarchyType, dyn_string &amp;exceptionInfo, bool allowApplyRemote=FALSE)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Recipes.ctl:386</div></div>
<div class="ttc" id="agroup__RecipeFunctions_html_ga90c82b459ca4938b22362a41ffecf141"><div class="ttname"><a href="group__RecipeFunctions.html#ga90c82b459ca4938b22362a41ffecf141">fwConfigurationDB_loadRecipeFromCache</a></div><div class="ttdeci">void fwConfigurationDB_loadRecipeFromCache(string recipeName, dyn_string deviceList, string hierarchyType, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo, string systemName=&quot;&quot;)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Recipes.ctl:199</div></div>
</div><!-- fragment --><h3><a class="anchor" id="qstart_recipe_apply"></a>
Apply Recipes</h3>
<p>To apply a recipe stored in <em>recipeObject</em> to the system use the <a class="el" href="group__RecipeFunctions.html#ga3c127700937f5b3144dcaaaa5c5a7c8a">fwConfigurationDB_applyRecipe</a> function.</p>
<p>To get a recipe data into a <em>recipeObject</em> you may load the data from database or a recipe cache using the functions described in <a class="el" href="index.html#qstart_recipe_load">Loading stored Recipes</a> . You may also create a <em>recipeObject</em> from a recipe template, create a custom <em>recipeObject</em> following the format of the <a class="el" href="index.html#recipeObject">recipeObject</a> , edit the existing recipe, or aggregate recipes taken from various sources by means of the <a class="el" href="group__RecipeFunctions.html#gaa03d6c4cc18c9cae3449b957f3b1324e">fwConfigurationDB_combineRecipes</a> function.</p>
<p>See subsection <a class="el" href="index.html#qstart_recipe_load">Loading stored Recipes</a> for a code example</p>
<h3><a class="anchor" id="qstart_recipe_create"></a>
Create Recipes</h3>
<p>Typically a new recipe is created in two steps: the data needs to be extracted from the running system and stored in <a class="el" href="index.html#recipeObject">recipeObject</a> , then it needs to be stored in the database of the recipe cache.</p>
<p>Before a recipe is extracted from the system, the recipe type needs to be set. By default, when <a class="el" href="group__ErrorCodes.html#ga43d05490668849e2a99e320f93ed38cf">fwConfigurationDB_initialize</a> is created, the default recipe type is preselected. A custom recipe type may be set using <a class="el" href="group__RecipeFunctions.html#gaa196c19ef16831e8ebccfdfa0b195ecf">fwConfigurationDB_setRecipeType</a> function.</p>
<p>To extract the recipe data from the running system (i.e. take a "snapshot" of the current settings) the <a class="el" href="group__RecipeFunctions.html#gad8c78e1c3ab9067aba9ece6320fa5a48">fwConfigurationDB_extractRecipe</a> function should be used.</p>
<p>Example: </p><div class="fragment"><div class="line">dyn_dyn_mixed recipeObject; <span class="comment">// recipe data will go here</span></div>
<div class="line">dyn_string deviceList;</div>
<div class="line">dyn_string exceptionInfo;</div>
<div class="line"><span class="keywordtype">string</span> hierarchyType=fwDevice_LOGICAL;</div>
<div class="line"> </div>
<div class="line"><span class="comment">// set the recipe type</span></div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#gaa196c19ef16831e8ebccfdfa0b195ecf">fwConfigurationDB_setRecipeType</a>(<span class="stringliteral">&quot;OnlyVoltages&quot;</span>, exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line"> </div>
<div class="line"><span class="comment">// extract the list of all items below ATLAS/EM/Barel/HV in logical hierarchy</span></div>
<div class="line"><span class="keywordtype">string</span> rootNode=getSystemName()+<span class="stringliteral">&quot;ATLAS/EM/Barel/HV&quot;</span>;</div>
<div class="line"><a class="code" href="fwConfigurationDB__Hierarchies_8ctl.html#a2160aaa26b8d3c747f689aeb4b4a4b69">fwConfigurationDB_getHierarchyFromPVSS</a>(rootNode, fwDevice_HARDWARE,</div>
<div class="line">                       deviceList, exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line"> </div>
<div class="line"><span class="comment">// get the recipe data</span></div>
<div class="line">fwConfigurationDB_exctractRecipe(deviceList, hierarchyType,</div>
<div class="line">                recipeObject, exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="ttc" id="agroup__RecipeFunctions_html_gaa196c19ef16831e8ebccfdfa0b195ecf"><div class="ttname"><a href="group__RecipeFunctions.html#gaa196c19ef16831e8ebccfdfa0b195ecf">fwConfigurationDB_setRecipeType</a></div><div class="ttdeci">void fwConfigurationDB_setRecipeType(string recipeType, dyn_string &amp;exceptionInfo, string systemName=&quot;&quot;)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Recipes.ctl:985</div></div>
</div><!-- fragment --><h3><a class="anchor" id="quickstart_recipe_store"></a>
Storing recipes</h3>
<p>The recipes contained in a <em>recipeObject</em> can be permanently stored in the database or, locally, in a recipe cache. The following functions are at programmer's disposal: </p><ul>
<li><a class="el" href="group__RecipeFunctions.html#ga5abee14f21a2a0153cedff1192fe09c5">fwConfigurationDB_saveRecipeToDB</a> stores a recipe contained in a <em>recipeObject</em> into the database </li>
<li><a class="el" href="group__RecipeFunctions.html#ga22139116b5f536eb790becddfe96ced0">fwConfigurationDB_saveDiffRecipeToDB</a> stored a differences, with respect to already stored recipe, in the database </li>
<li><a class="el" href="group__RecipeFunctions.html#ga0bc019a9d021d27bacd6402828b8ab72">fwConfigurationDB_saveRecipeToCache</a> stores a recipe contained in a <em>recipeObject</em> into recipe cache; note that if a recipe cache with the same name already exists, it will be overwritten; otherwise: a new recipe cache, with given recipe name, will be created automatically by means of <a class="el" href="group__RecipeFunctions.html#ga464e74b6b3b1faa3cca3826f785bd088">fwConfigurationDB_createRecipeCache</a> .</li>
</ul>
<h3><a class="anchor" id="qstart_recipe_templates"></a>
Recipe templates</h3>
<p>Recipe templates are an effective way of creating a recipes that contain same settings for a number of devices: the idea is to define the configuration data for a single device only, then provide the list of devices which should have this settings applied. Recipe templates are used by means of the <a class="el" href="group__RecipeFunctions.html#gac9a61a16359cbaebba3749f765e01f2a">fwConfigurationDB_makeRecipeFromTemplate</a> function.</p>
<p>Any recipeObject may play a role of the recipe template; for instance, the settings for one of HV channels, that are stored in recipe cache may be loaded, then used to create a recipe that will use these settings for the whole HV subsystem, or a few boards of a HV crate.</p>
<p>A recipe template (we use this term to refer to templRecipeObject variable of the <a class="el" href="group__RecipeFunctions.html#gac9a61a16359cbaebba3749f765e01f2a">fwConfigurationDB_makeRecipeFromTemplate</a> function) may contain the settings for more than one device types, e.g. it may contain settings for a CAEN channel, a CAEN board and a CAEN crate. The appropriate settings from the template will then be used (based on the device type information) to select the settings for devices from the device list.</p>
<p>In the example below we will use a part of "hv_ramp" recipe stored in a recipe cache (strictly speaking: the settings for the first channel and the crate) to create recipe template. Then, we will use such template to create a recipe for the whole HV crate called "CAEN/crate1". </p><div class="fragment"><div class="line">dyn_string exceptionInfo;</div>
<div class="line">dyn_dyn_mixed templateRecipeObject, recipeObject;</div>
<div class="line"> </div>
<div class="line"><span class="comment">// load a part of recipe from cache: only two devices are involved!</span></div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#ga90c82b459ca4938b22362a41ffecf141">fwConfigurationDB_loadRecipeFromCache</a>(<span class="stringliteral">&quot;hv_ramp&quot;</span>,</div>
<div class="line">        makeDynString(<span class="stringliteral">&quot;SubSys/HvChannel001&quot;</span>,</div>
<div class="line">                      <span class="stringliteral">&quot;SubSys/HVCrate&quot;</span>),</div>
<div class="line">        fwDevice_LOGICAL, templateRecipeObject,exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line"> </div>
<div class="line"><span class="comment">// make a device list containing the whole CAEN crate.</span></div>
<div class="line"><span class="keywordtype">string</span> deviceList;</div>
<div class="line"><a class="code" href="fwConfigurationDB__Hierarchies_8ctl.html#a2160aaa26b8d3c747f689aeb4b4a4b69">fwConfigurationDB_getHierarchyFromPVSS</a> (getSystemName()+<span class="stringliteral">&quot;CAEN/crate01&quot;</span>,</div>
<div class="line">            fwDevice_HARDWARE, deviceList, exceptionInfo);</div>
<div class="line"> </div>
<div class="line"><span class="comment">// use the template and the device list to create the recipe.</span></div>
<div class="line"><span class="comment">// note that the template used settings for LOGICAL hierarchy,</span></div>
<div class="line"><span class="comment">// and we create recipe for HARDWARE hierarchy!</span></div>
<div class="line"> </div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#gac9a61a16359cbaebba3749f765e01f2a">fwConfigurationDB_makeRecipeFromTemplate</a> (deviceList, fwDevice_HARDWARE,</div>
<div class="line">                                    templateRecipeObject, recipeObject, exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)) {fwExceptionHandling_display(exceptionInfo); <span class="keywordflow">return</span>;}</div>
<div class="line"> </div>
<div class="line"><span class="comment">// the recipeObject contains the settings for the whole CAEN crate now...</span></div>
<div class="ttc" id="agroup__RecipeFunctions_html_gac9a61a16359cbaebba3749f765e01f2a"><div class="ttname"><a href="group__RecipeFunctions.html#gac9a61a16359cbaebba3749f765e01f2a">fwConfigurationDB_makeRecipeFromTemplate</a></div><div class="ttdeci">void fwConfigurationDB_makeRecipeFromTemplate(dyn_string deviceNames, string hierarchyType, dyn_dyn_mixed templRecipeObject, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Recipes.ctl:891</div></div>
</div><!-- fragment --><h3><a class="anchor" id="qstart_recipe_adhoc"></a>
"Manual" creation of recipes</h3>
<p>The recipe data is stored in a <code>dyn_dyn_mixed</code> variable with quite complex structure. Even though it is possible to create an "ad hoc" recipe object by filling in the fields in an array, it is much more convenient to use a dedicated fuction: <a class="el" href="group__RecipeFunctions.html#ga22139116b5f536eb790becddfe96ced0">fwConfigurationDB_saveDiffRecipeToDB</a> to accomplish this task.</p>
<p>To create a recipeObject using this function it is sufficient to provide two lists: one with the list of datapoint element names (with names of devices from any of supported hierarchies), and a list of corresponding settings for these device elements. Note that setting up alerts in this way is not possible at the moment.</p>
<p>The following example demonstrates the use of the function: </p><div class="fragment"><div class="line">dyn_string deviceElements;</div>
<div class="line">dyn_mixed settings;</div>
<div class="line"> </div>
<div class="line">deviceElements[1]=<span class="stringliteral">&quot;dist_1:CAEN/crate1.Commands.Kill&quot;</span>;</div>
<div class="line">settings[1]=TRUE;</div>
<div class="line"> </div>
<div class="line">deviceElements[2]=<span class="stringliteral">&quot;MyDetector/ECAL/HV/channel000.settings.v0&quot;</span>;</div>
<div class="line">settings[2]=12.34;</div>
<div class="line"> </div>
<div class="line"><span class="comment">// this device is on remote system, yet it is visible!</span></div>
<div class="line">deviceElements[3]=<span class="stringliteral">&quot;dist_2:CAEN/crate1/board00/channel004.settings.v1&quot;</span>;</div>
<div class="line">settings[3]=56.78;</div>
<div class="line"> </div>
<div class="line"><span class="comment">// this logical device is again on remote system, yet it is visible...</span></div>
<div class="line">deviceElements[4]=<span class="stringliteral">&quot;MyDetector2/ECAL/HV/straw4.settings.i1&quot;</span>;</div>
<div class="line">settings[4]=135.7;</div>
<div class="line"> </div>
<div class="line">dyn_dyn_mixed recipeObject;</div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#gaae65e15b082d2cbf72e0cc19570b8bdd">fwConfigurationDB_makeRecipe</a>(deviceElements, settings, recipeObject, exceptionInfo, TRUE);</div>
<div class="ttc" id="agroup__RecipeFunctions_html_gaae65e15b082d2cbf72e0cc19570b8bdd"><div class="ttname"><a href="group__RecipeFunctions.html#gaae65e15b082d2cbf72e0cc19570b8bdd">fwConfigurationDB_makeRecipe</a></div><div class="ttdeci">void fwConfigurationDB_makeRecipe(dyn_string deviceElements, dyn_mixed settings, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo, bool checkExists=TRUE)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Recipes.ctl:4129</div></div>
</div><!-- fragment --><p> In the example above, the recipe will contain 4 elements, for various devices being in local and also in a remote system. Note that both: HARDWARE and LOGICAL devices may be specified and mixed.</p>
<p>Note that the last parameter passed into the function has the TRUE value. It signifies that the created recipeObject will be filled with maximum of information that may be guessed from the local and remote systems. This, however, requires that all specified devices exist. Such complete recipe (if it contained only local devices, no remote ones) could be immediately applied to a system, stored in a cache or in the database.</p>
<p>However, sometimes one might need to create a recipe (e.g. for future use) that would contain the devices that not yet exist (or devices on remote systems, which are not connected to the current system). In such situation one might specify the last parameter in the call to <a class="el" href="group__RecipeFunctions.html#gaae65e15b082d2cbf72e0cc19570b8bdd">fwConfigurationDB_makeRecipe</a> to be FALSE. In such situation, only minimal verification of the device list is performed, and in particular the devices do not need to exist. Such recipe is not complete. It may not be applied to a system, or stored in a cache. It may, however, be stored in the database! It is then the database's task to complete the missing parts of recipe - the database may do that because the missing information is stored in the static configuration data!</p>
<h3><a class="anchor" id="qstart_recipe_otherFunctions"></a>
Other Functions</h3>
<p>Let us now enumerate the remaining functions, which may be of general interest.</p>
<ul>
<li>To edit the contents of a recipeObject one may use the <a class="el" href="group__RecipeFunctions.html#ga7335b71a07e76cec90ffdc870e86781c">fwConfigurationDB_editRecipe</a> function, which opens an appropriate panel. </li>
<li>To visualize the contents of a recipeObject, it is not always useful to dump its contents using <em>DebugN(recipeObject);</em>. A much more flexible way is to use the <a class="el" href="group__RecipeFunctions.html#ga7335b71a07e76cec90ffdc870e86781c">fwConfigurationDB_editRecipe</a> function in the read-only mode. </li>
<li>To compare two recipe objects one may use the <a class="el" href="fwConfigurationDB__Recipes_8ctl.html#ab29437a79bcc38d36a84cdc15c1f4680">fwConfigurationDB_compareRecipes</a> function, which returns a recipeObject with differences. </li>
<li>To substitute the system name in recipes in HARDWARE hierachy which were stored with another system name one may use the <a class="el" href="fwConfigurationDB__Recipes_8ctl.html#ae6fe539c8e11d0f8a8a3b72ff2377ad3">fwConfigurationDB_adoptRecipeObjectToSystem</a> function. </li>
<li>To get a meta-information (i.e. description) of a recipe one may use fwConfigurationDB_GetDBRecipeMetaInfo and <a class="el" href="fwConfigurationDB__Deprecated_8ctl.html#a92033885a1d8788d0cb5028e91040105">fwConfigurationDB_GetRecipeCacheMetaInfo</a> functions. </li>
<li>To create a new, empty recipe in cache one may use the <a class="el" href="group__RecipeFunctions.html#ga464e74b6b3b1faa3cca3826f785bd088">fwConfigurationDB_createRecipeCache</a> function. This function will return an error if a cache with specified name already exists, hence it may be used to protect the recipe caches from being overwritten by mistake with new values.</li>
</ul>
<h2><a class="anchor" id="qstart_hierarchies"></a>
Hierarchies</h2>
<p>(documentation not yet completed)</p>
<h1><a class="anchor" id="dataStructures"></a>
Data Structures</h1>
<p>PVSS has a limited set of basic data types. Therefore we decided to apply on a naming convention to refer to "objects" passed and returned in functions, using these basic types (dyn_X , dyn_dyn_X or mapping PVSS types).</p>
<p>The convention specifies the name of the variable in the definition of the function parameter. For instance, all the functions that used a recipeObject data structure (described below) will have it listed explicitly as "mapping recipeObject" in the list of the parameters.</p>
<h2><a class="anchor" id="recipeObject"></a>
recipeObject</h2>
<p>The recipeObject data structure contains the data of a recipe. In PVSS it is handled using dyn_dyn_mixed data type. The data concerning recipe for a data point element, is stored in lines. Each column, all of which are the same length, store a part of the recipe data for the data point element; the first column is the "key" column - it stores the full names of the data point elements. The columns are refered to using pre-defined constants, which are described in subsection <a class="el" href="group__recipeObjectIndices.html">Indices used to refer to recipeObject variables</a> . The structure of the recipeObject is shown in the figure below:</p>
<table style="font-size:8;">
<tr bgcolor="yellow">
<td># </td><td>Data point element </td><td>DP Name  </td><td>DP Type </td><td>element </td><td>element type </td><td>has value  </td><td>has alert </td><td>value </td><td>alert active </td><td>... other alert settings  </td></tr>
<tr>
<td>1 </td><td>dist1:AnalogDigital/ai1.value </td><td>dist1:AnalogDigital/ai1 </td><td>FwAnalogInput </td><td>.value </td><td>22 (DPEL_FLOAT) </td><td>FALSE </td><td>TRUE </td><td></td><td>TRUE </td><td>...  </td></tr>
<tr>
<td>2 </td><td>dist1:AnalogDigital/ao1.value </td><td>dist1:AnalogDigital/ao1 </td><td>FwAnalogOutput </td><td>.value </td><td>22 (DPEL_FLOAT) </td><td>TRUE </td><td>FALSE </td><td>3.14  </td></tr>
</table>
<p>Although the type of each single cell of the table is "mixed", which allows for storing any data type (including dynamic data types), we decided to store the property value in the encoded form. The _fwConfigurationDB_dataToString and _fwConfigurationDB_stringToData functions are used to encode and decode the data into a string. The other parts of data, including lists of alert texts, alert classes, etc are stored using their native types inside the recipeObject. For more information about the conventions, please refer to subsection <a class="el" href="index.html#recipeDataStorageConventions">Conventions for recipe data storage</a> .</p>
<h2><a class="anchor" id="connectionInfo"></a>
connectionInfo</h2>
<h2><a class="anchor" id="RTData"></a>
RTData</h2>
<p>The RTData object is used as a transient data storage space for Recipe Type data, where the data is edited in RecipeTypeEdit.pnl panel. It is a dyn_dyn_string-typed variable, with the following structure:</p>
<ul>
<li>RTData[i][1] : device type name </li>
<li>RTData[i][2] : device dptype name </li>
<li>RTData[i][3] : dp element </li>
<li>RTData[i][4] : property name </li>
<li>RTData[i][5] : save value </li>
<li>RTData[i][6] : save alert</li>
</ul>
<p>the "i" index refers to the entries for subsequent dpes of dpts. Each entry could be uniquely identified by RTData[i][2] and RTData[i][3] entries.</p>
<p>Convention: for the Framework devices RTData[i][1] will store the Framework Device Name according to device definitions, e.g. "CAEN Board", and the RTData[i][2] will store the actual data point type, e.g. FwCaenChannel. For non-framework data poin types, both: RTData[i][1] and RTData[i][2] will contain the data point type. This way one can in fact distinguish the Framework and non-Framework entries by checking if RTData[i][1] and RTData[i][2] are the same.</p>
<h1><a class="anchor" id="conventions"></a>
Conventions</h1>
<h2><a class="anchor" id="recipeDataStorageConventions"></a>
Conventions for recipe data storage</h2>
<p>The following conventions for data encoding are used for recipes.</p>
<table class="doxtable">
<tr bgcolor="yellow">
<td bgcolor="lightgreen">what/where </td><td>System </td><td>recipeObject </td><td>recipe cache </td><td>database  </td></tr>
<tr>
<td bgcolor="lightblue">property value </td><td><em>any type</em>  </td><td>as string  </td><td>as string  </td><td>as string   </td></tr>
<tr>
<td bgcolor="lightblue">alert active </td><td>bool  </td><td>bool  </td><td>as string  </td><td>as string   </td></tr>
<tr>
<td bgcolor="lightblue">alert limits </td><td>dyn_float  </td><td>dyn_float  </td><td>as string  </td><td>as string   </td></tr>
<tr>
<td bgcolor="lightblue">alert texts </td><td>dyn_string  </td><td>dyn_string  </td><td>as string  </td><td>as string   </td></tr>
<tr>
<td bgcolor="lightblue">alert classes </td><td>dyn_string  </td><td>dyn_string  </td><td>as string  </td><td>as string   </td></tr>
</table>
<p>The _fwConfigurationDB_dataToString and _fwConfigurationDB_stringToData functions are used to encode and decode the data into a string. The "|" character is used as a separator when dynamic-list-typed variables are stored.</p>
<h1><a class="anchor" id="others"></a>
Others</h1>
<ul>
<li><a class="el" href="group__ErrorCodes.html">Error Codes</a> returned in exceptionInfo </li>
<li><a class="el" href="group__recipeObjectIndices.html">Indices used to refer to recipeObject variables</a> </li>
</ul>
</div></div><!-- PageDoc -->
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
